VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "AtomSoftTech Raw Sector Read"
   ClientHeight    =   5790
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   9015
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   5790
   ScaleWidth      =   9015
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton PrevBtn 
      Caption         =   "Prev."
      Height          =   255
      Left            =   5760
      TabIndex        =   7
      Top             =   150
      Width           =   1215
   End
   Begin VB.CommandButton NextBtn 
      Caption         =   "Next"
      Height          =   255
      Left            =   7200
      TabIndex        =   6
      Top             =   150
      Width           =   1215
   End
   Begin VB.DriveListBox Drive1 
      Height          =   315
      Left            =   120
      TabIndex        =   4
      Top             =   120
      Width           =   1935
   End
   Begin VB.TextBox SectTxt 
      Height          =   285
      Left            =   2760
      TabIndex        =   3
      Text            =   "0"
      Top             =   120
      Width           =   1455
   End
   Begin VB.TextBox Text2 
      Height          =   5175
      Left            =   4560
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   2
      Text            =   "Form1.frx":0000
      Top             =   600
      Width           =   4455
   End
   Begin VB.TextBox Text1 
      Height          =   5175
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Text            =   "Form1.frx":0006
      Top             =   600
      Width           =   4455
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Read"
      Height          =   255
      Left            =   4320
      TabIndex        =   0
      Top             =   150
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Sector"
      Height          =   375
      Left            =   2160
      TabIndex        =   5
      Top             =   165
      Width           =   1335
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Const FILE_BEGIN = 0
Const FILE_SHARE_READ = &H1
Const FILE_SHARE_WRITE = &H2
Const CREATE_NEW = 1
Const OPEN_EXISTING = 3
Const GENERIC_READ = &H80000000
Const GENERIC_WRITE = &H40000000
Private Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, ByVal lpOverlapped As Any) As Long
Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Any, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function SetFilePointer Lib "kernel32" (ByVal hFile As Long, ByVal lDistanceToMove As Long, lpDistanceToMoveHigh As Long, ByVal dwMoveMethod As Long) As Long

Public Function ReadSector(Sector As Long, Drive As String)
Dim dh As Long, ret As Long
Dim strBuffer As String
Dim bBytes(512) As Byte

Dim HexV As String
Dim StrV As String
Dim x As Long

Sector = Sector * 512
Drive = UCase(Drive)

dh = CreateFile("\\.\" & Drive & ":", GENERIC_READ, FILE_SHARE_READ Or FILE_SHARE_WRITE, ByVal 0&, OPEN_EXISTING, 0, 0)

If dh = -1 Then
 MsgBox "Could not open drive " & Drive & ":"
 End
End If

SetFilePointer dh, Sector, 0, FILE_BEGIN

ReadFile dh, bBytes(1), UBound(bBytes), ret, ByVal 0&

CloseHandle (dh)

Text1.Text = ""
Text2.Text = ""
For x = 1 To UBound(bBytes)
    HexV = Hex(bBytes(x))
    Text1.Text = Text1.Text & HexV & ","

    StrV = Chr(bBytes(x))
    Text2.Text = Text2.Text & StrV
Next x
End Function

Public Sub Command1_Click()
    Dim tmp As String
        tmp = Mid$(Drive1.Drive, 1, 1)
    If IsNumeric(SectTxt.Text) = False Then
        MsgBox "BAD SECTOR!"
        Exit Sub
    End If
    
    ReadSector SectTxt.Text, tmp
    
End Sub

Private Sub NextBtn_Click()
Dim x As Integer
x = Int(SectTxt.Text)

x = x + 1

SectTxt.Text = Str(x)

    Dim tmp As String
        tmp = Mid$(Drive1.Drive, 1, 1)
    If IsNumeric(SectTxt.Text) = False Then
        MsgBox "BAD SECTOR!"
        Exit Sub
    End If
    
    ReadSector SectTxt.Text, tmp
    
End Sub

Private Sub PrevBtn_Click()
Dim x As Integer
x = Int(SectTxt.Text)

If x > 0 Then x = x - 1

SectTxt.Text = Str(x)

    Dim tmp As String
        tmp = Mid$(Drive1.Drive, 1, 1)
    If IsNumeric(SectTxt.Text) = False Then
        MsgBox "BAD SECTOR!"
        Exit Sub
    End If
    
    ReadSector SectTxt.Text, tmp
    
End Sub

